#include "types.h"
#include "pnc.h"
#include "shared.h"

static PNC_cta_param_block cta_PB;  /* declare a static parameter block */

/* macro to fill and an atomic_cta parameter block to perform a fetch_and_add
   and return the result */

#define fetch_and_add16(addr, incr)\
(cta_PB.cta_incr = incr, cta_PB.cta_addr = (short *)addr, \
 cta_PB.cta_mask = 0, perform_cta = &cta_PB, cta_PB.cta_oldvalue)


extern int vpid;

void simple_barrier()
{
	if (vpid == 0) {
		CD->barrier_count = 1;
		CD->barrier_flag = 1;
		while (CD->barrier_count != CD->num_nodes) Sleep(100);

		/* now everybody is up to the barrier */
		CD->barrier_flag = 0;
		fetch_and_add16(&(CD->barrier_count),-1);
		while (CD->barrier_count != 0) Sleep(100);
	}
	else {
		while(CD->barrier_flag != 1) Sleep(100);
		fetch_and_add16(&(CD->barrier_count),1);
		while(CD->barrier_flag != 0) Sleep(100);
		fetch_and_add16(&(CD->barrier_count),-1);
	}
}

