#include "pnc.h" 

#define FANIN 4
#define NULL 0

typedef unsigned char boolean;
#define False ((boolean) 0)
#define True ((boolean) 1)

PNC_cta_param_block count_cta_parms;

typedef struct CTREE {
	short count;
	short child_count;
	volatile boolean locksense;
	struct CTREE *parent;
} treenode;

extern treenode *shared_array[];
extern int num_nodes;
extern int vpid;

treenode *my_leaf;
boolean sense;


void combining_barrier_init()
{
	int i, index, power, lognodes, interior_nodes = 0;
	treenode *node;
	count_cta_parms.cta_mask = 0;
	count_cta_parms.cta_incr = 1; /* initialize for increments */
	for(lognodes=0,power=1;power < num_nodes; power<<=1,lognodes++);
	for(i=1;(i * FANIN) <= num_nodes; i *= FANIN) interior_nodes += i;
	index = interior_nodes + vpid/FANIN;
	my_leaf = shared_array[index];
	node = my_leaf;
	for(; node ;) { /* initialize combining tree from the leafs up */
		count_cta_parms.cta_addr = &node->child_count;
		perform_cta = &count_cta_parms;
		count_cta_parms.cta_addr = &node->count;
		perform_cta = &count_cta_parms;
		if (count_cta_parms.cta_oldvalue != 0) break; 
		else {
			if (index == 0) node->parent = (treenode *) NULL;
			else {
				index = (index -1)/FANIN;
				node->parent = shared_array[index];
			}
		}
		node = node->parent;
	}
	count_cta_parms.cta_incr = -1; /* initialize for decrements */
	sense = True;
	shared_array[vpid]->locksense = False;
}


void combining_barrier_aux(node)
treenode *node;
{
	count_cta_parms.cta_addr = &node->count;
	perform_cta = &count_cta_parms;
	if (count_cta_parms.cta_oldvalue == 1) {
		if (node->parent) combining_barrier_aux(node->parent);
		node->count = node->child_count;
		node->locksense ^= True;
	}
	else while(node->locksense != sense);
}

void combining_barrier()
{
	combining_barrier_aux(my_leaf);
	sense ^= True;
}
