#define PARITIES 2

#define shared
#define private
#define P     256
#define LogP     8
typedef unsigned char boolean;
#define False ((boolean) 0)
#define True ((boolean) 1)

extern shared int num_nodes;
extern private int vpid;

typedef struct {
	boolean answers[PARITIES][LogP];
	boolean *intended[PARITIES][LogP];
} localnode;

extern localnode *shared_array[256]; 

private short log_nodes;
private localnode *node;
private boolean **first_intended[PARITIES];
private boolean *first_answer[PARITIES];
private boolean parity, sense;

void dissemination_barrier_init()
{
	short power,instance,k;
	for(log_nodes=0,power=1;power < num_nodes; power<<=1,log_nodes++);
	node = shared_array[vpid];
	for(k=0;k<PARITIES;k++) {
		first_intended[k] = &node->intended[k][0]; 
		first_answer[k] = &node->answers[k][0];
	}
    power = 1;
    for(instance = 0; instance <= log_nodes -1; instance++) {
		for(k=0;k<PARITIES;k++) {
			node->intended[k][instance] = 
				&(shared_array[(power + vpid) % num_nodes]->answers[k][instance]);
			node->answers[k][instance] = False;
		}
        power = power * 2;
    }
	parity = False;
	sense = True;
}

void dissemination_barrier()
{
	register boolean **intended, *ans; 
	register boolean sense_reg = sense;
	if (parity ^= True) { intended = first_intended[0]; ans = first_answer[0]; }
	else { intended = first_intended[1]; ans = first_answer[1]; sense ^= True; }
	switch(log_nodes) {
	case 8: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 7: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 6: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 5: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 4: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 3: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 2: **intended++ =  sense_reg; while (*ans != sense_reg); ans++;
	case 1: **intended++ =  sense_reg; while (*ans != sense_reg); 
	}
}
