/* Copyright 1987 Bolt Beranek and Newman Inc. */
/* All Rights Reserved */
/* program to monitor average switch transaction time */

#include <public.h>
#include <stdio.h>


#define INTERVAL 3000
#define STATS_NAME "Probe.STATS"


/* figure out which nodes can be probed */
int present[256];
int Nnodes;


procedure MarkNode(pn)		/* second arg ignored */
int pn;
{
    present[Nnodes] = pn;
    Nnodes++;
}


procedure Init()
{
    int i;

    Nnodes = 0;
    For_All_Nodes(MarkNode, 0);
	Nnodes--; /* leave out last node */
	for(i=0;i<Nnodes;i++)
		printf("%x ", present[i]);
}


/* do one probe run and put in stats */
DoProbe()
{
    unsigned int t1, t2, t3;
    unsigned int delta;
    int i;
    int junk;
	short oldAsAr;


	oldAsAr = entkerin;
    t1 = rtc;

    for (i=0; i<Nnodes; i++) {
		DQ_PB.dq_handle = (present[i]<<24);	/* always illegal OID */
		dq_poll = &DQ_PB;
	}

    t2 = rtc;

    for (i=0; i<Nnodes; i++) {
		DQ_PB.dq_handle = (present[i]<<24);	/* always illegal OID */
	    junk = (int) &DQ_PB; /* do nothing (measures overhead) */
	}

    t3 = rtc;
	AsAr = oldAsAr;

    /* compute time/transaction for this pass (in uS) */
    delta = (((t2-t1)-(t3-t2))*125/2) / Nnodes;

    /* put time in stats */
    printf(" %d us/transaction\n", delta);	/* *** for now *** */
}


main(argc, argv)
int argc;
char * argv[];
{
    Init();

    printf("Type <return> to stop\n");
    while (!ChannelHasInput(stdin)) {
	DoProbe();
    Sleep(INTERVAL);	/* don't poll continuously */	
	}
    getchar();
}
