/***************************************************************** 
	from the expanded TR version of the ICPP paper
	guarantees FIFO ordering.
	spins locally if you have coherent caches and you arrange for
	all the flag bits to be in separate cache lines.
	avoids the flurry of bus traffic when a lock is released.
	requires space for the lock linear in the number of processors.
	may have a counter overflow problem.
 *****************************************************************/

typedef struct {
	short queue_last;
} alock;

typedef struct {
	unsigned short locked_flag;
} alink;

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

unsigned short alock_lock() asm("anderson_lock");

#define alock_lock(lockaddr) \
({	/* pass lockaddr in a1 instead of on the stack */ \
	asm volatile ( "movl %0,a1 | pass addr of alock in a1": /* no outputs */ :\
		/* input */ "g" ( lockaddr ): /* clobbered */ "a1" ); \
	/* return value from block is my_place */ alock_lock(); \
})

#define alock_unlock(lockaddr,my_place) { \
	register short place = my_place;\
	if (++place == num_nodes) {\
		shared[0]->distributed_locks.a_link.locked_flag = FALSE; \
	} else { \
		shared[place]->distributed_locks.a_link.locked_flag = FALSE; \
	} \
}
