#include <public.h>
#include <stdio.h>

#define MY_NODE -1

#include "simple.h"
#include "ticket.h"
#include "anderson.h"
#include "mcs.h"
#include "shared.h"

extern short vpid;

void init_tight_barrier()
{
	int parent = vpid/2;

	if (vpid == 0) return;

	if (vpid & 1) shared[parent]->left = &shared[vpid]->my_flag;
	else shared[parent]->right = &shared[vpid]->my_flag;
}

void simple_barrier()
{
	if (vpid == 0) {
		SV->barrier_count = 1;
		SV->barrier_flag = 1;
		while (SV->barrier_count != SV->num_procs) Sleep(100);

		/* now everybody is up to the barrier */
		SV->barrier_flag = 0;
		Atomic_add(&(SV->barrier_count),-1);
		while (SV->barrier_count != 0) Sleep(100);
	}
	else {
		while(SV->barrier_flag != 1) Sleep(100);
		Atomic_add(&(SV->barrier_count),1);
		while(SV->barrier_flag != 0) Sleep(100);
		Atomic_add(&(SV->barrier_count),-1);
	}
}


void tight_barrier()
{
	if (vpid == 0) {
		SV->barrier_count = 1;
		SV->barrier_flag = 1;
		while (SV->barrier_count != SV->num_procs) Sleep(100);

		/* now everybody is up to the barrier */
		SV->barrier_count = 0;
		SV->barrier_flag = 0;
	}
	else {
		while(!SV->barrier_flag) Sleep(100);
		shared[vpid]->my_flag = 1;
		Atomic_add(&SV->barrier_count,1);
		while(shared[vpid]->my_flag);
	}

	if (shared[vpid]->right) *shared[vpid]->right = 0;
	if (shared[vpid]->left) *shared[vpid]->left = 0;
}

void final_barrier()
{
	if (vpid == 0) {
		SV->barrier_count = 1;
		SV->barrier_flag = 1;
		while (SV->barrier_count != SV->num_procs) Sleep(100);

		/* now everybody is up to the barrier */
		Post_Event(SV->main_event, 0);
	}
	else {
		while(!SV->barrier_flag) Sleep(100);
		shared[vpid]->my_flag = 1;
		Atomic_add(&SV->barrier_count,1);
	}
	Wait();
}
