#include <public.h>
#include <stdio.h>

#include "util.h"
#include "simple.h"
#include "ticket.h"
#include "anderson.h"
#include "mcs.h"
#include "shared.h"

#define STACK_SIZE (60 K)
#define NUM_ARGS 3
#define MAX_PROCS SWITCH_SIZE
#define TICKS_PER_SEC 16000
#define MY_NODE -1

int num_procs = 0;
int node_list[MAX_NODES];
OID children[MAX_NODES];
char *process_argv[NUM_ARGS];/* Pointers to arguments to the process */
OID shared_obj_id;

struct SV_struct *SV;
struct SV2_struct *shared[MAX_NODES];

void build_proc_array(int id, long dummy)
{
	dummy = dummy; 
	if (id == pnn) return;
	node_list[num_procs++] = id;
}

main()
{
	void spawn_children();

	void For_All_Nodes(void *, long);

	For_All_Nodes((void *)build_proc_array, 0);
	shared_obj_id = Make_Obj(0,MY_NODE,sizeof(struct SV_struct), RW_rw_);
	SV = (struct  SV_struct*) Map_Obj(shared_obj_id,0,RW_rw_);
	SV->num_procs = num_procs;
	SV->barrier_flag = 0;
	SV->barrier_count = 0;
	SV->main_event = Make_Event(0,0,0,0);
	spawn_children();

/* 	for(int i=0;i<SV->num_procs;i++) {
		shared[i] = (struct  SV2_struct*) 
			Map_Obj(SV->shared_segoid[i],0,RW_rw_);
	}
*/

	MWait(SV->main_event,0);

}

#define MAX_ARG_SIZE 20     /* Max string argument size (in bytes) */
char string_space[200];     /* Stores argument strings to child process */

void spawn_children()
{
    OID template_OID;
    OID arg_OID;
    CP_ARGS process;	/* Record to hold arguments to Make_Process */
    int proc_cnt;
    int arg_cnt;

    catch

	/* Allocate string space for each argument */
	for (arg_cnt = 0; arg_cnt < NUM_ARGS; arg_cnt++) {
	    process_argv[arg_cnt] = &string_space[arg_cnt*MAX_ARG_SIZE];
	}

	/* Store values in argument strings */

	process_argv[0] = "spintest";
	/* Argument [1] is the vpid and is set individually below */
	sprintf(process_argv[2],"%d",shared_obj_id);

	catch
		template_OID = Find_Value("spintest.68", NTYPE_OBJ);
	onthrow
		when(TRUE) {
			template_OID = Load_Process("spintest.68",-1,200,STACK_SIZE);
		}
	endcatch;

	/* Only set fields not set in template or in Fork_Process */
	/* process.cp_pn supplied below */
	process.cp_type = CP_CHILD;     /* Make the new process a child */
	process.cp_flags = CP_PRIV;     /* run on creation */
	process.cp_name = NULL;         /* No template name provided here */
	process.cp_spec = template_OID; /* Template OID for process */
	process.cp_prot = R_Xr_x;
	process.cp_prio = 1;
	process.cp_slice = 10;
	process.cp_need = 20;
	process.cp_stksz = STACK_SIZE;
	process.cp_stkloc = 0;
	/* process.cp_arg1 supplied below */
	process.cp_arg2 = NULL;
	process.cp_start = 0;
	process.cp_segs = 200;
	process.cp_msegsize = 0;
	process.cp_exit_eh = NULL;


	for (proc_cnt = 0; proc_cnt < num_procs; proc_cnt++) {

	    /* Fork another process */


	    /* Pass the process its virtual processor number */
	    sprintf(process_argv[1],"%d",proc_cnt);

	    /* Create arguments for the process */
	    arg_OID = Create_Args(node_list[proc_cnt],NUM_ARGS,process_argv,NULL);

	    process.cp_pn = node_list[proc_cnt];	/* Node to run process on */
	    process.cp_arg1 = arg_OID; 	/* Argument object */

	    /* Create the process */
	    children[proc_cnt] = Make_Process(&process);

	    /* Give the argument object to the child */
	    Disown_Obj(arg_OID, children[proc_cnt]);
	} /* end for */

    onthrow
	when (TRUE) {
	    printf("* Error in %s procedure spawn_children *\n",
			"spintest_master");
	    printf("%s\n",throwtext);
	    rethrow;
	}
    endcatch;

}  /* spawn_children */
