/***************************************************************** 
	John and my algorithm
	guarantees FIFO ordering
	spins locally even if you don't have coherent caches
	no unusual space requirements
 *****************************************************************/
typedef struct MLINK {
	struct MLINK* successor;
	unsigned short locked;
} mlink;

extern mlink *my_link;

#define NONE ((unsigned short)~0)

typedef struct MLOCK {
	unsigned short tail;
} mlock;

void init_M ();

#define mlock_lock(lockaddr) \
asm volatile("	movl %0,d0  | move lockaddr to d0": :"g" ( lockaddr ) : "d0");\
asm volatile("	movl #1$,d1" : : : "d1" );\
asm volatile("	jmp mlock_lock" : : : "d0", "d1", "a0", "a1" ) ;\
asm volatile("1$: " );


#define mlock_unlock(lockaddr) \
asm volatile(".globl _my_link");\
asm volatile("	movl _my_link,a1" : : : "a1" );\
asm volatile("	movl a1@,d0		| load my_link->successor, set cc": : : "d0");\
asm volatile("	bne 2$			| to have successor");\
asm volatile("	movl %0,d0		| move lockaddr to d0": :"g" (lockaddr):"d0");\
asm volatile("	pea 3$			| push return address on stack");\
asm volatile("	jmp mlock_unlock_helper": : : "d0", "d1", "a0", "a1" ) ;\
asm volatile("2$:				| have_successor");\
asm volatile("	movl d0,a0" : : : "a0");\
asm volatile("	clrw a0@(4)		| ... ->locked = FALSE");\
asm volatile("3$:")
