/***************************************************************** 
	simple dumb spin on remote fetch-and-phi
 *****************************************************************/

#include <public.h>
#include "simple.h"
#include "util.h"

#ifndef USE_ASM
	fail
#endif USE_ASM

#define A(s) asm volatile(s);

struct PNC_am simple_cta_block;
void init_S ()
{
	/* the hand-coded assembler uses its own special ctl blk for speed */
	simple_cta_block.am_mask = 0xffff;
	simple_cta_block.am_incr = 1;
}

static void simple()
{
A ("	| assembly version of simple lock 									")
A ("	| parameter: pointer to lock in d0									")
A ("	| parameter: return address in a1 									")
A ("	.text																")
A ("	.even																")
A (".globl slock_lock														")
A ("slock_lock:																")
A ("	| don't need an fp													")
A ("	| no non-volatiles to save											")
A ("	movl #_simple_cta_block,a0											")
A ("	| fill in control block for test&set:								")
A ("	movl d0,a0@				| fill in &slock.locked in ctl blk			")
A ("poll_again:																")
A ("	movl a0,0xffffd100		| execute fetch-and-phi poll				")
A ("	tstw a0@(8)				| was the lock available?					")
A ("	bne poll_again			| continue polling 							")
A ("	jmp a1@																")
}

static void simpleexp()
{
A ("	| assembly version of simple lock with exponential backoff			")
A ("	| parameter: pointer to lock in d0									")
A ("	| parameter: return address in a1 									")
A ("	.text																")
A ("	.even																")
A (".globl slockexp_lock													")
A ("slockexp_lock:															")
A ("	| don't need an fp													")
A ("	| no non-volatiles to save											")
A ("	movl #_simple_cta_block,a0											")
A ("	| fill in control block for test&set:								")
A ("	movl d0,a0@				| fill in &slock.locked in ctl blk			")
A ("	movl a0,0xffffd100		| execute fetch-and-phi poll				")
A ("	tstw a0@(8)				| was the lock available?					")
A ("	bne exp_do_poll			| continue polling with backoff				")
A ("	jmp a1@					| return to caller 							")
A ("exp_do_poll:															")
A ("	clrl d1					| initialize exponent of delay count		")
A ("exp_poll_again:															")
A ("	addql #1,d1				| increase exponent of delay count			")
A ("	moveq #1,d0				| compute delay 							")
A ("	asll d1,d0				| ... left shifting by delay exponent 		")
A ("	cmpw _nodes_in_test,d0	| compare delay with number of procs		")
A ("	blt exp_delay  			| if delay < maximum allowable				")
A ("	movw _nodes_in_test,d0	| set delay to maximum value				")
A ("exp_delay:																")
A ("	dbra d0,exp_delay		| delay loop								")
A ("	movl a0,0xffffd100		| execute fetch-and-phi poll				")
A ("	tstw a0@(8)				| was the lock available?					")
A ("	bne exp_poll_again		| if not, back off and poll again			")
A ("	jmp a1@					| return to caller 							")
}

static void simplelin()
{
A ("	| assembly version of simple lock with linear backoff				")
A ("	| parameter: pointer to lock in d0									")
A ("	| parameter: return address in a1 									")
A ("	.text																")
A ("	.even																")
A (".globl slocklin_lock													")
A ("slocklin_lock:															")
A ("	| don't need an fp													")
A ("	| no non-volatiles to save											")
A ("	movl #_simple_cta_block,a0											")
A ("	| fill in control block for test&set:								")
A ("	movl d0,a0@				| fill in &slock.locked in ctl blk			")
A ("	movl a0,0xffffd100		| execute fetch-and-phi poll				")
A ("	tstw a0@(8)				| was the lock available?					")
A ("	bne lin_do_poll			| continue polling with backoff				")
A ("	jmp a1@					| return to caller 							")
A ("lin_do_poll:															")
A ("	clrl d1						| polling collisions					")
A ("lin_poll_again:															")
A ("	addql #1,d1					| increase delay						")
A ("	movl d1,d0					| set up delay loop						")
A ("lin_delay:																")
A ("	dbra d0,lin_delay			| delay loop							")
A ("	movl a0,0xffffd100			| execute fetch-and-phi poll			")
A ("	tstw a0@(8)					| was it zero before?					")
A ("	bne lin_poll_again			| continue polling until lock clear		")
A ("	jmp a1@					| return to caller 							")
}
