#include <public.h>
#include <stdio.h>

#define MY_NODE -1

#include "simple.h"
#include "ticket.h"
#include "anderson.h"
#include "mcs.h"
#include "shared.h"
#include "barrier.h"


struct SV_struct *SV;
struct SV2_struct *shared[256];

OID shared_obj_id;
short vpid;
short num_nodes;
main(argc,argv)
int argc;
char **argv;
{
	int i;
	vpid = atoi(argv[1]);
	shared_obj_id = atoi(argv[2]);
	SV = (struct  SV_struct*) Map_Obj(shared_obj_id,0,RW_rw_);
	SV->shared_segoid[vpid] = Make_Obj(0,MY_NODE,sizeof(struct SV_struct), 0);
	num_nodes = SV->num_procs;
	simple_barrier();

	/*	before the barrier, each processor has entered the id for its shared 
		segment into the table SV->shared_segoid.  map in shared area for 
		each processor using the segment ids from the global table */
	for(i=0;i<SV->num_procs;i++) {
		shared[i] = (struct  SV2_struct*) 
			Map_Obj(SV->shared_segoid[i],0,RW_rw_);
	}

	/*	the shared areas are set up, initialize pointers in the 
		shared area that are used for tight barrier synchronization */
	init_tight_barrier();
	simple_barrier();

	/* 	the tight barrier initialization is complete, synchronize
		before performing the timing tests */
	tight_barrier();

	/*	perform the timing tests */
	synchtest();

	/*	terminate the computation signalling the main program that forked
		all of the slaves for the spintest */
	final_barrier(); 
}
