/***************************************************************** 
	slightly smarter: take ticket and spin on remote read
	guarantees FIFO ordering
	with coherent caches, this would spin locally until an unlock,
	at which point there would be a flurry of bus traffic and
	then everybody would settle in again
 *****************************************************************/


typedef struct  {
	unsigned short next_ticket;
	unsigned short now_serving;
} tlock;


inline void init_T () { }

inline unsigned short
tlock_lock(l)
volatile tlock *l;
{
	static struct PNC_am ticket_cta_block = { 
		/* short *am_addr */ 		0,  
		/* short bits am_mask */ 	0, 
		/* short am_incr */ 		1, 
		/* short am_oldvalue */		0 
	};
	register unsigned short temp;

	ticket_cta_block.am_addr = (short *) &l->next_ticket;
	addmem = &ticket_cta_block;
	temp = (unsigned short) ticket_cta_block.am_oldvalue;
	while (temp != l->now_serving);
	return temp;
}

inline tlock_unlock(l, my_place)
volatile tlock *l;
short my_place;
{
	l->now_serving = my_place+1; 
}

#define A(x) asm volatile(x)

inline unsigned short
tlockdel_lock(l)
volatile tlock *l;
{
	static struct PNC_am ticket_cta_block = { 
		/* short *am_addr */ 		0,  
		/* short bits am_mask */ 	0, 
		/* short am_incr */ 		1, 
		/* short am_oldvalue */		0 
	};
	register unsigned short temp, delay;

	ticket_cta_block.am_addr = (short *) &l->next_ticket;
	addmem = &ticket_cta_block;
	temp = (unsigned short) ticket_cta_block.am_oldvalue;
	while (delay = (temp - l->now_serving)) {
		for (--delay; --delay >= 0;) {
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop"); A ("    nop"); A ("    nop"); A ("    nop");
			A ("    nop");
		}
	}
	return temp;
}

#define tlockdel_unlock tlock_unlock
