#define P 		18

typedef unsigned char  boolean;
#define True ((boolean) 1)
#define False ((boolean) 0)

typedef union {
	long whole;
	boolean parts[4];
} whole_and_parts;

typedef struct {
	boolean *parentflag;
	whole_and_parts havechild;
	whole_and_parts childnotready;
	boolean dummy;
	int pad[4];
} localnode;

shared localnode shared_array[P];
shared boolean champion_sense = False;

private boolean sense;
private localnode *mynode;

extern int vpid;
extern int num_nodes;


void arrivaltree_barrier_init()
{
	int i,child_id;
	mynode = &shared_array[vpid];
	if (vpid == 0) mynode->parentflag = &mynode->dummy;
	else {
		int parentid = (vpid -1)/4;
		int my_index = vpid - (parentid * 4) - 1;
		mynode->parentflag = 
			&shared_array[parentid].childnotready.parts[my_index];
	}
	for(i=0,child_id = 4 * vpid + 1;i<4;i++,child_id++) {
		 /* have child i in arrival tree */
		mynode->havechild.parts[i] = (num_nodes > child_id);
	}
	mynode->childnotready.whole = mynode->havechild.whole;
	sense = True;
}


void arrivaltree_barrier()
{
	register localnode *mynode_reg = mynode;
	while (mynode_reg->childnotready.whole);
	mynode_reg->childnotready.whole = mynode_reg->havechild.whole; 
	*mynode_reg->parentflag = False;
	if (!vpid) champion_sense = sense;
	else while(champion_sense != sense);
	sense ^= True;
}
