typedef enum {False,True} boolean;

shared int count;
shared int dummy[3]; /* ensure separate cache lines for count and sense */
shared boolean sense;

private boolean local_sense;

extern int vpid;
extern int num_nodes;

void central_barrier_init()
{
	count = num_nodes;
	sense = False;
	local_sense = False;
}

void central_barrier()
{
	local_sense ^= True;
	asm(" lock"); asm(" decl _count"); /* atomic decrement */
	asm(" jne busy_wait");             /* if count > 0 then busy wait */
	count = num_nodes;
	sense = local_sense;
	return;
asm("busy_wait:");
	while(sense != local_sense);
}
