#define LogP     5
#define PARITIES 2

typedef enum {False,True} boolean;

typedef struct {
	boolean answers[PARITIES][LogP];
	boolean *intended[PARITIES][LogP];
} localnode;

shared localnode shared_array[256]; 
extern shared int num_nodes;
extern private int vpid;

private int log_nodes;
private localnode *mynode;
private boolean **myfirst_intended[PARITIES];
private boolean *myfirst_answer[PARITIES];
private boolean *mylast_answer[PARITIES];
private boolean parity, sense;

void dissemination_barrier_init()
{
	short power,instance,k;
	for(log_nodes=0,power=1;power < num_nodes; power<<=1,log_nodes++);
	mynode = &shared_array[vpid];
	for(k=0;k<PARITIES;k++) {
		myfirst_intended[k] = &mynode->intended[k][0]; 
		myfirst_answer[k] = &mynode->answers[k][0];
		mylast_answer[k] =  &mynode->answers[k][log_nodes-1];
	}
    power = 1;
    for(instance = 0; instance <= log_nodes -1; instance++) {
		for(k=0;k<PARITIES;k++) {
			mynode->intended[k][instance] = 
				&(shared_array[(power + vpid) % num_nodes].answers[k][instance]);
			mynode->answers[k][instance] = False;
		}
        power = power * 2;
    }
	parity = False;
	sense = True;
}

void dissemination_barrier()
{
	register boolean **intended = myfirst_intended[parity];
	register boolean *answer = myfirst_answer[parity];
	register boolean *answer_last = mylast_answer[parity];
	do {
		**intended++ =  sense;
		while (*answer != sense);
	} while (++answer <= answer_last);
	sense ^= parity;
	parity ^= True;
}
