#define P 18

typedef unsigned char  boolean;
#define True ((boolean) 1)
#define False ((boolean) 0)

typedef union {
	long whole;
	boolean parts[4];
} whole_and_parts;

typedef struct {
	boolean *parentflag;
	boolean *child_notify[2];
	whole_and_parts havechild;
	whole_and_parts childnotready;
	boolean wakeup_sense;
	boolean dummy;
	int pad[4];
} treenode;

shared treenode shared_array[P];

private boolean sense;
private boolean *last_child;
private treenode *mynode;

extern int vpid;
extern int num_nodes;

void tree_barrier_init()
{
	int i,child_id;
	mynode = &shared_array[vpid];
	if (vpid == 0) mynode->parentflag = &mynode->dummy;
	else {
		int parentid = (vpid -1)/4;
		int my_index = vpid - (parentid * 4) - 1;
		mynode->parentflag = 
			&shared_array[parentid].childnotready.parts[my_index];
	}
	for(i=0,child_id = 2 * vpid + 1;i<2;i++,child_id++) {
		if (num_nodes > child_id)  /* have child i in wakeup tree */
			mynode->child_notify[i] = &shared_array[child_id].wakeup_sense;
		else  /* don't have child i in wakeup tree */
			mynode->child_notify[i] = &mynode->dummy;
	}
    for(i=0,child_id = 4 * vpid + 1;i<4;i++,child_id++) {
         /* have child i in arrival tree */
        mynode->havechild.parts[i] = (num_nodes > child_id);
    }

    mynode->childnotready.whole = mynode->havechild.whole;
	mynode->wakeup_sense = False;
	sense = True;
}


void tree_barrier()
{
	register treenode *mynode_reg = mynode;
	while (mynode_reg->childnotready.whole);
	mynode_reg->childnotready.whole = mynode_reg->havechild.whole; 
	*mynode_reg->parentflag = False;
	if (vpid) while(mynode_reg->wakeup_sense != sense);
	*mynode_reg->child_notify[0] = sense;
	*mynode_reg->child_notify[1] = sense;
	sense ^= True;
}
