typedef struct locklist {
	struct locklist *next;
	int *flag;
} LockList;

typedef struct lockspace {
	int val;
	int tmp[3];
	LockList *next;
	int tmp2[3];
	LockList queue[NUMPROCS + 2];
	int flags[CACHE_WORDS * (NUMPROCS + 2)];
} Lock;

void init_queue();

/* Assumes lock is already held */
asm void HOARE_LOCK(laddr)
{
%reg laddr; lab Hloop;
/PEEPOFF
	movl	16(laddr),%eax		/* p = l->next */
	movl	(%eax),%ecx			/* q = p->next */			
	movl	%ecx,16(laddr)		/* l->next = q */
	movb	$0,(laddr)			/* release lock */
	movl	4(%ecx),%edx
	movl	%edx,_myl			/* myl = q->flag */
	movl	4(%eax),%eax		/* p = p->flag */
Hloop: cmpb	$0,(%eax)
	je		Hloop
	movb	$0,(%eax)
/PEEPON
}

asm void HOARE_UNLOCK()
{
	movl	_myl,%eax
	movb	$1,(%eax)
}

#define BACKMASK               31

asm void BACKOFF4_LOCK(laddr,seed,old)
{
%reg laddr, seed, old; lab loop, tmp, wait, newdelay, done;
/PEEPOFF
	shrb	$1,old
	orb		$1,old
	movb	$1, %al
loop:
	cmpb	%al, (laddr)
	je     newdelay
	xchgb	%al, (laddr)		/* an atomic "test and set" */
	cmpb	$0, %al
	je	done			/* if equal, we got the lock */
		/* SAME AS ABOVE */
tmp: movb   $1, %al		/* NOT NECESSARY */
	cmpb	$BACKMASK,old
	je		newdelay
	addb	old,old
	orb		$1,old
newdelay:			 /* compute backoff */
	imull   $1103515245,seed
	addl    $12345,seed
	movl	seed,%ecx
	andb	old,%cl
	cmpb	$0, %cl
	je		loop
wait: decb	%cl
	jnz		wait	
	jmp		loop
done:
/PEEPON
}
#define ANDERSON_LOCK_INIT(l) { \
	init_queue(l); \
	(l)->val = 0; \
	(l)->next = (l)->queue; \
	(l)->flags[0] = 1; 	/* set first location to grab lock */ \
}

#define ANDERSON_LOCKB(l,s,o)	{ \
	BACKOFF4_LOCK(l,s,o); \
	HOARE_LOCK(l); \
}

#define ANDERSON_LOCKS(l)	{ \
	SIMPLE_LOCK(l); \
	HOARE_LOCK(l); \
}

#define ANDERSON_UNLOCK(l) HOARE_UNLOCK()

extern LockList *anderson_lock_b();
