	.data
	.align 2
_seed_and:
	.int 0
_old_and:
	.byte 1
	.text

	.globl _anderson_init_b
	.align 2
_anderson_init_b:
	movl    4(%esp),%eax
	movl	%eax,_seed_and
	movl    8(%esp),%eax
	movb    %al,_old_and
	ret

	.globl _anderson_lock_b
	.align 2
_anderson_lock_b:
# parameter list
# 	old 	%ah
# 	seed	%ecx
#	laddr	%edx
	movb	_old_and,%ah
	shrb	$1,%ah
	orb		$1,%ah
	movb	$1, %al				# use %al for test&set on lock 
	movl    4(%esp),%edx		# load laddr into %edx
outloop:
	cmpb	$1, (%edx)
	je     newdelay
	xchgb	%al, (%edx)			# an atomic "test and set" 
	cmpb	$0, %al
	je	queue					# if equal, we got the lock 
tmp: 
	cmpb	$31,%ah
	je		newdelay
	addb	%ah,%ah
	orb		$1,%ah
	movb	%ah,_old_and
newdelay:			 /* compute backoff */
	movl	_seed_and,%ecx
	imull   $1103515245,%ecx
	addl    $12345,%ecx
	movl	%ecx,_seed_and
	andb	%ah,%cl
	cmpb	$0, %cl
	je		outloop
waitloop: 
	decb	%cl
	jnz		waitloop	
	jmp		outloop
queue:
	movl	16(%edx),%eax		# p = l->next 
	movl	(%eax),%ecx			# q = p->next			
	movl	%ecx,16(%edx)		# l->next = q
	movb	$0,(%edx)			# release outer lock 
# reuse %edx here for p
	movl	4(%eax),%edx		# p = p->flag 
	movl	4(%ecx),%eax		# return q->flag in %eax
inloop: cmpb	$0,(%edx)
	je		inloop
	movb	$0,(%edx)			# clear my proceed flag
	ret


	.globl _anderson_unlock_b
_anderson_unlock_b:
#	q->flag	%edx
	movl    4(%esp),%eax
	movb	$1,(%eax)			# clear the inner lock
	ret
