#	void mcs_lock(spinitem **lock, spinitem *item)
#	{
#		item->next = 0;
#		oldtail = fetch-and-store(lock,item);
#		if (oldtail) {
#			item->locked = TRUE;
#			oldtail->next = item;
#			while(item->locked);
#		}
#	}

	.globl _mcs_lock;
	.align 2
_mcs_lock:
		movl	4(%esp),%eax;	# addr of lock
		movl	8(%esp),%ecx;	# addr of item
		movl	$0,(%ecx);		# item->next = 0;
		movl	%ecx,%edx;		# copy of item addr for swap
		xchgl	(%eax),%edx;	# oldtail = fetch-and-store(lock,item);

		testl 	%edx,%edx;		# if (oldtail) {
		je 		done;
		movb	$1,4(%ecx);		# 	item->locked = TRUE;
		movl	%ecx,(%edx);	# 	oldtail->next = item;

while:	
		cmpb 	$1,4(%ecx);		# 	while(item->locked);
		je	 	while;
								# }
done:	
		ret;

#	void mcs_unlock(spinitem **lock, spinitem *item)
#	{
#		if (!item->next) {
#			tail = fetch-and-store(lock,0);
#			if (tail == item) return;
#			usurper = fetch-and-store(lock,tail);
#			while (!item->next); /* wait for successor */
#			if (usurper) {
#				usurper->next = item->next;
#				return;
#			}
#		} 
#		item->next->locked = FALSE;
#	}

	.globl _mcs_unlock;
	.align 2
_mcs_unlock:
		movl	8(%esp),%ecx;	# addr of item

		cmpl	$0,(%ecx)		# if (!item->next) {
		jne 	pass_lock;

no_successor:
		movl	$0,%edx;		# 	/* prepare to swap nil into lock */
		movl	4(%esp),%eax;	# 	load addr of lock into reg
		xchgl	(%eax),%edx;	# 	tail = fetch-and-store(lock,0);

		cmpl 	%ecx,%edx;		# 	if (tail == item) return;
		jne 	unlk_fixup;
		ret;

unlk_fixup:
		xchgl	(%eax),%edx;	# 	usurper = fetch-and-store(lock,tail);

unlk_while:	
		cmpl 	$0,(%ecx);		# 	while (!item->next); 
		je	 	unlk_while;			

		cmpl 	$0,%edx;		# 	if (usurper)
		jne		usurper_found;

pass_lock:
		movl	(%ecx),%edx		# 	item->next->locked = FALSE;
		movb	$0,4(%edx);
		ret;

usurper_found:
		movl    (%ecx),%eax		#	usurper->next = item->next;
		movl    %eax,(%edx)	
		ret
