typedef unsigned long us_ticks;

#define REPEAT_COUNT 1000000

#define RUN_TEST(HIGHEST_NODE,DECLS,LOOP_BODY) \
		barrier(); \
		if (HIGHEST_NODE >= vpid) {\
			us_ticks start_time, end_time; \
			register int i; \
			DECLS; \
			start_time = GETUSCLK(); \
			for (i=repeat_count; i--;) LOOP_BODY; \
			end_time = GETUSCLK(); \
			elapsed_time[vpid] = end_time - start_time; \
			barrier(); \
		} \
		else { elapsed_time[vpid] = 0; barrier(); }

#define RUN_TEST_ALL(NAME,HIGHEST_NODE,DECLS,LOOP_BODY) { \
	int nodes_in_test, repeat_count;\
	nodes_in_test = HIGHEST_NODE + 1; \
	repeat_count = REPEAT_COUNT / nodes_in_test;\
	if (vpid == 0) { \
		printf("%s\n",NAME);\
		printf("Spin Lock test %2d processors, %8d iterations/processor, ", nodes_in_test, repeat_count);\
	} \
	RUN_TEST (HIGHEST_NODE, DECLS, LOOP_BODY); \
	if (vpid == 0) { \
		int i = 0; \
		short pmax = 0; \
		us_ticks max = elapsed_time[0]; \
		for(i = 1; i <= HIGHEST_NODE; i++) \
			if (max < elapsed_time[i]) { max = elapsed_time[i]; pmax = i; } \
		printf("time = %10d usec\n", max);\
	} \
	barrier (); \
}
